
#include-once
#include <Clipboard.au3>

#include <Process.au3>
#Include <Array.au3>

#include <Memory.au3>		; (for _Mem..() funcs) [actually included in <ClipBoard.au3>, but here for clarity]


#cs

TranzVoo is based on one of my "glosslookup" scripts.  Those scripts helped translators look up terms in a glossary.  The TranzVoo also looks up "terms" in what might be called a glossary, but the current script checks only for exact matching "terms".

New in version 3: If anything is selected, the search is based on that selection.  If nothing is selected, the search is based on the source text.

#ce

$slowpoke = 0

Global $fileopenhtml, $glossaryfilecolumns, $glossaryfilelines, $glossaryfileopen, $glossaryfileopendialog, $glossaryfileread, $grabbedtext, $grabbedword, $grabbedwordarray, $htmloutput, $i, $j, $k, $l, $output, $found

Global $isanarray = 1

; MsgBox (0, "TranzVoo for Wordbee", "TranzVoo looks up strings in a mini-TM, for use with Wordbee.  Read the instructions in the readme.txt file." & @CRLF & @CRLF & "Shortcuts:" & @CRLF & @CRLF & "` (under Esc key) = find translation of source cell, and paste it into the current cell" & @CRLF & "Shift + ` = same as `, but 5 times slower" & @CRLF & "Ctrl + ` = tries to select text without leading and trailing tags" & @CRLF & "` with text selected = find translation of selected text, and paste it over the selected text" & @CRLF & "WinKey + Q = Exit the program (or right-click its icon)", 0)

MsgBox (0, "TranzVoo for Wordbee", "TranzVoo looks up strings in a mini-TM, for use with Wordbee.  Read the instructions in the readme.txt file." & @CRLF & @CRLF & "Shortcuts:" & @CRLF & @CRLF & "` (under Esc key) = find translation of source cell, paste it into the current cell, and move to next cell" & @CRLF & "Shift + ` = find translation of source cell, and paste it into the current cell" & @CRLF & "WinKey + Q = Exit the program (or right-click its icon)" & @CRLF & @CRLF & "Alternatively:" & @CRLF & @CRLF & "Alt+Insert = find translation of source cell, and paste it into the current cell" & @CRLF & "Alt+Down = move to next cell", 0)

HotKeySet("`", "seekandpasteandgo")
HotKeySet("+`", "seekandpaste")
HotKeySet("!{INSERT}", "seekandpaste")

; HotKeySet("^`", "trytohighlight")
; HotKeySet("1", "trytohighlight2")

HotKeySet("#q", "exitty")

; ### FIRST READ MINI TM

; In the Wordbee version, the mini TM has 3 columns.  Read columns 2 and 3.

$glossaryfileopendialog = FileOpenDialog ("Select mini-TM", @ScriptDir, "Text files (*.txt)|All files (*.*)") ; uncomment this to be asked for glossary at start of run

#cs
$glossaryfileopendialog = @ScriptDir & "\mini-TM.txt" ; comment this if you uncomment the above
#ce

$glossaryfileopen = FileOpen ($glossaryfileopendialog, 128) ; 128 means UTF8, 32 means UTF16LE
$glossaryfileread = FileRead ($glossaryfileopen)

$glossaryfilelines = StringSplit ($glossaryfileread, @CRLF, 3)

Global $glossaryfilefirstcolumn[UBound ($glossaryfilelines)]
Global $glossaryfilesecondcolumn[UBound ($glossaryfilelines)]
Global $glossaryfilethirdcolumn[UBound ($glossaryfilelines)]

For $i = 0 to UBound ($glossaryfilelines) - 1
$glossaryfilecolumns = StringSplit ($glossaryfilelines[$i], @TAB, 3)
If UBound ($glossaryfilecolumns) > 1 Then ; i.e. if there is more than 1 column in the line
$glossaryfilefirstcolumn[$i] = $glossaryfilecolumns[0]
$glossaryfilesecondcolumn[$i] = $glossaryfilecolumns[1]
$glossaryfilethirdcolumn[$i] = $glossaryfilecolumns[2]

$glossaryfilefirstcolumn[$i] = StringReplace ($glossaryfilefirstcolumn[$i], "{{CRLF}}", @CRLF)
$glossaryfilesecondcolumn[$i] = StringReplace ($glossaryfilesecondcolumn[$i], "{{CRLF}}", @CRLF)
$glossaryfilethirdcolumn[$i] = StringReplace ($glossaryfilethirdcolumn[$i], "{{CRLF}}", @CRLF)

$glossaryfilefirstcolumn[$i] = StringReplace ($glossaryfilefirstcolumn[$i], "{{TAB}}", @TAB)
$glossaryfilesecondcolumn[$i] = StringReplace ($glossaryfilesecondcolumn[$i], "{{TAB}}", @TAB)
$glossaryfilethirdcolumn[$i] = StringReplace ($glossaryfilethirdcolumn[$i], "{{TAB}}", @TAB)

#cs
$glossaryfilefirstcolumn[$i] = StringTrimLeft ($glossaryfilefirstcolumn[$i], 2)
$glossaryfilesecondcolumn[$i] = StringTrimLeft ($glossaryfilesecondcolumn[$i], 2)
$glossaryfilethirdcolumn[$i] = StringTrimLeft ($glossaryfilethirdcolumn[$i], 2)

$glossaryfilefirstcolumn[$i] = StringTrimRight ($glossaryfilefirstcolumn[$i], 2)
$glossaryfilesecondcolumn[$i] = StringTrimRight ($glossaryfilesecondcolumn[$i], 2)
$glossaryfilethirdcolumn[$i] = StringTrimRight ($glossaryfilethirdcolumn[$i], 2)
#ce

EndIf
Next

; MsgBox (0, "", _ArrayToString($glossaryfilefirstcolumn, " | "), 0) ; If you want to check that the entire glossary was read
; MsgBox (0, "", _ArrayToString($glossaryfilesecondcolumn, " | "), 0) ; If you want to check that the entire glossary was read

While 1
Sleep ("100")
WEnd


Func exitty ()
Exit
EndFunc


Func slowseekandpaste()
$slowpoke = 1
Send ("`")
EndFunc

Func seekandpasteandgo()
Send ("+`")
Send ("!{DOWN}")
EndFunc


Func seekandpaste ()

Send ("^a")
Sleep ("50")
Send ("+^c")
Sleep ("50")
Send ("^a")
Sleep ("50")
Send ("^x")
Sleep ("300")

$grabbedtextraw = ClipGet()
$grabbedtexthtml = _ClipGetHTML ()

If NOT IsArray ($grabbedtexthtml) Then
MsgBox (0, "Error", "Is not an array... erm... can't help, mate.", 0)
$isanarray = 0
Else
$sUnicodeHTML=BinaryToString($grabbedtexthtml[0],4)
; $sUnicodeHTML=BinaryToString(StringToBinary($grabbedtexthtml[0],4),1)
$grabbedtexthtmlfrag = $sUnicodeHTML

#cs
$grabbedtexthtmlfrag = StringReplace ($grabbedtexthtmlfrag, @CRLF, "{{CRLF}}")
$grabbedtexthtmlfrag = StringReplace ($grabbedtexthtmlfrag, @LF, "{{LF}}")
$grabbedtexthtmlfrag = StringReplace ($grabbedtexthtmlfrag, @TAB, "{{TAB}}")

$grabbedtextraw = StringReplace ($grabbedtextraw, @CRLF, "{{CRLF}}")
$grabbedtextraw = StringReplace ($grabbedtextraw, @LF, "{{LF}}")
$grabbedtextraw = StringReplace ($grabbedtextraw, @TAB, "{{TAB}}")
#ce

EndIf

$output = ""
$found = 0

For $m = 0 to UBound ($glossaryfilelines) - 1

If $found = 0 Then
If StringCompare ($grabbedtexthtmlfrag, $glossaryfilesecondcolumn[$m], 1) =  0 Then
$output = $glossaryfilethirdcolumn[$m]
$found = 1
EndIf
EndIf

Next

If $found = 0 Then
MsgBox (0, "No translation found!", "TransVoo could not find a translation for [" & $grabbedtextraw & "].", 0)
ClipPut ($grabbedtextraw)
Send ("^z")
Send ("^z")
Else

#cs
$output = StringReplace ($output, "{{CRLF}}", @CRLF)
$output = StringReplace ($output, "{{LF}}", @LF)
$output = StringReplace ($output, "{{TAB}}", @TAB)
#ce

$sHTMLStr = $output

$sHTMLStr=BinaryToString(StringToBinary($sHTMLStr,4),1)

_ClipPutHTML($sHTMLStr)

Sleep ("100")
Send ("^v")
Sleep ("100")

$slowpoke = 0

EndIf

EndFunc









































; ==============================================

; The ClipGetHTML function is here below:

; ===============================================================================================================================
; <_ClipGetHTML.au3>
;
; Function to get HTML formatted text from the Clipboard.
;
; Functions:
;	_ClipGetHTML()			; Function to get HTML code (in UTF-8 format) from the clipboard (if it exists in that format),
;							;	NOTE: The PlainText version (usually available) can also be gotten with a call to ClipGet()
;
; NOTES: ClipBoard DLL calls as of AutoIT 3.3 do not have error checking.
;
; Dependencies: <Clipboard.au3>,  <Memory.au3>
;
; See also:
;	<_ClipPutHTML.au3>
;	<TestClipPutHTML.au3>
;	<_ClipPutHTML_w_History.au3>
;	<_ClipGetRTF.au3>
;	<TestHTMLClipBoardMonitor.au3>	; Monitors & Reports on HTML-formatted ClipBoard data
;	<TestRTFClipBoardMonitor.au3>
;	<_RTF_PullHyperlinks.au3>
;	<TestClipBoardHyperlinkReSorter.au3>; On a HotKey, will pull Hyperlinks from HTML- or RTF-formatted Clipboard data,
;										; 	sort and resubmit them to the Clipboard (in isolated, sorted format)
;
; Resources:
;	CF_HTML (# 49342) Format @ MSDN: http://msdn.microsoft.com/en-us/library/ms649015(VS.85).aspx
;	Clipboard Formats @ MSDN: http://msdn.microsoft.com/en-us/library/ms649013(VS.85).aspx
;
; Author: Ascend4nt, Paul Campbell (PaulIA) for original _ClipBoard_GetData() UDF (<ClipBoard.au3>)
; ===============================================================================================================================


#cs
; --------------------------------------
- SAMPLE IE HTML ClipBoard Header text -
Version:1.0
StartHTML:000000185
EndHTML:000008453
StartFragment:000003866
EndFragment:000008417
StartSelection:000003887
EndSelection:000008417
SourceURL:http://www.google.com/
{HTML START HERE}
; --------------------------------------
#ce


; ===============================================================================================================================
; Func _ClipGetHTML()
;
; Method to get HTML data from the clipboard, and to place the different elements in an array.
;
; NOTE: PlainText variant of the ClipBoard data is NOT retrived (though it can be added to this function if you please)
;	Reason: Caller can simply do a call to ClipGet() right before/after a call to this function
;
; IMPORTANT: Returned HTML Data is in UTF-8 format. The offsets into the returned HTML Data string
;	should be used PRIOR to doing any types of Unicode conversions, as the offsets are based on
;	the # of characters (including the multiple characters required to produce certain Unicode characters)
;
; Returns:
;	Success: an array of data regarding the retrieved data, with @error = 0. Array format:
;		$array[0] = HTML Data String (in UTF-8 encoding)
;		$array[1] = Version # as a string (typically "0.9" or "1.0")
;		$array[2] = Fragment Start [where in the HTML Data String the actual copied portion fragment begins)
;		$array[3] = Fragment End (where "" "" fragment ends)
;		$array[4] = Selection Start (optional, -1 if unavailable): Where in the HTML Data String,
;		   and also within the FragmentStart->FragmentEnd portion, where the *selection* starts
;		$array[5] = Section End (optional, -1 if unavailable): "" "" *selection* ends
;		$array[6] = Source URL (optional, "" if unavailable). For webpage data, this is typically a normal URL,
;			but for document editors, helpfiles, and such, it can be information that has to be interpreted differently
;			(you'll have to examine it to figure this part out)
;		$array[7] = The Original CF_HTML Header as it came from the ClipBoard.  This is mostly useful
;			only if the data needs to be sent BACK to the ClipBoard (adding this before the HTML Data String)
;			(Note that offsets in the CF_HTML Header string will not match those in the rest of the array,
;			due to adjustments needed (removing the size of the Header))
;
; Failure: "" with @error set:
;		@error = -1 = no HTML data in CilpBoard
;		@error = -2 = error opening ClipBoard
;		@error = -3 = error trying to retrieve ClipBoard data
;		@error = -4 = error locking the Memory Object
;		@error = -6 = StartHTML/EndHTML identifiers not found in ClipBoard's HTML Header
;		@error = -9 = error registering HTML Data Clipboard format (no attempt to get CF_HTML #)
;
; Author: Ascen4nt, Paul Campbell (PaulIA) for original _ClipBoard_GetData() UDF (<ClipBoard.au3>)
; ===============================================================================================================================

Func _ClipGetHTML()
	;  CF_HTML in experimentation is generally 49342, but we'll use the proper method here
	Local $iCF_HTMLFormat=_ClipBoard_RegisterFormat("HTML Format")

	If $iCF_HTMLFormat=0 Then Return SetError(-9,@error,"")

	If Not _ClipBoard_IsFormatAvailable($iCF_HTMLFormat) Then Return SetError(-1,@error,"")

	If Not _ClipBoard_Open(0) Then Return SetError(-2, 0, "")
	Local $hMemory=_ClipBoard_GetDataEx($iCF_HTMLFormat)

	If $hMemory=0 Then
		_ClipBoard_Close()
		Return SetError(-3, 0, "")
	EndIf

	Local $pMemoryBlock=_MemGlobalLock($hMemory)

	If $pMemoryBlock=0 Then
		_ClipBoard_Close()
		Return SetError(-4,0,"")
	EndIf

#cs
	; Proper way to get the actual memory size to use in creating a DLL Structure (in bytes):

	Local $iDataSize=DllCall("Kernel32.dll","int","GlobalSize","hwnd",$hMemory)

	; or better (though no @error handling as of AutoIt v3.3.0.0):
	;	Local $iDataSize=_MemGlobalSize($hMemory)

	If @error Or Not $iDataSize[0] Then
		_MemGlobalUnlock($hMemory)
		_ClipBoard_Close()
		Return SetError(-5,0,"")
	EndIf
	$iDataSize=$iDataSize[0]
#ce

	; Knowing the format, we are safe using this small Structure which is less than the minimum needed
	;  for a full HTML ClipBoard data object. We only need to grab 2 fields, so the smaller, the better
	Local $stData=DllStructCreate("char[64]",$pMemoryBlock)

	Local $sHTMLHeader=DllStructGetData($stData,1)
	; Get the actual size of data to retrieve
	Local $iHTMLEnd=StringRegExp($sHTMLHeader,"(?i)EndHTML:(\d+)",1)
	; Also get the size of the header to make retrieving it less painful later (if the HTML data is huge)
	Local $iHTMLStart=StringRegExp($sHTMLHeader,"(?i)StartHTML:(\d+)",1)

	; Were we successful in retrieving both?
	If Not IsArray($iHTMLStart) Or Not IsArray($iHTMLEnd) Then
		; No 'StartHTML:####' and/or no 'EndHTML:####' found? Return failure
		_MemGlobalUnlock($hMemory)
		_ClipBoard_Close()
		Return SetError(-6,0,"")
	Else
		; Convert the 1-element arrays to numbers
		$iHTMLStart=Number($iHTMLStart[0])
		$iHTMLEnd=Number($iHTMLEnd[0])
	EndIf

	; Now that we have the full HTML-Data size, we'll grab the whole thing
	$stData=DllStructCreate("char["&$iHTMLEnd&']',$pMemoryBlock)
	Local $sHTMLData=DllStructGetData($stData,1)

	; Clear the structure
	$stData=0

	; Unlock the memory & Close the clipboard now that we have grabbed what we needed
	_MemGlobalUnlock($hMemory)
	_ClipBoard_Close()

	; Get the (now-FULL) Header
	$sHTMLHeader=StringLeft($sHTMLData,$iHTMLStart)
	; Remove the header so that only the HTML data is left
	$sHTMLData=StringTrimLeft($sHTMLData,$iHTMLStart)

	; Now gather the Header Data (some components are optional)
	Local $iFragmentStart=StringRegExp($sHTMLHeader,"(?i)StartFragment:(\d+)",1)
	Local $iFragmentEnd=StringRegExp($sHTMLHeader,"(?i)EndFragment:(\d+)",1)
	; Though not optional, we'll treat them as such, and give them
	;	defaults of HTMLStart/HTMLEnd
	If IsArray($iFragmentStart) Then
		; Adjust +1 to rectify position
		$iFragmentStart=Number($iFragmentStart[0])+1
	Else
		$iFragmentStart=$iHTMLStart
	EndIf

	If IsArray($iFragmentEnd) Then
		$iFragmentEnd=Number($iFragmentEnd[0])
	Else
		$iFragmentEnd=$iHTMLEnd
	EndIf

	; The following 3 are optional header fields
	Local $iSelectionStart=StringRegExp($sHTMLHeader,"(?i)StartSelection:(\d+)",1)
	Local $iSelectionEnd=StringRegExp($sHTMLHeader,"(?i)EndSelection:(\d+)",1)

	If IsArray($iSelectionEnd) Then
		$iSelectionEnd=Number($iSelectionEnd[0])
	Else
		$iSelectionEnd=-1
	EndIf

	If IsArray($iSelectionStart) Then
		; Adjust +1 to rectify position
		$iSelectionStart=Number($iSelectionStart[0])+1
	ElseIf $iSelectionEnd=-1 Then
		$iSelectionStart=-1
	Else
		; Selection End was found, but selection start not? Just set it to Fragment Start
		$iSelectionStart=$iFragmentStart
	EndIf

	Local $sSourceURL=StringRegExp($sHTMLHeader,"(?i)SourceURL:([^ \r\n\z]+)",1)
	If @error Then
		$sSourceURL=""
	Else
		$sSourceURL=$sSourceURL[0]
	EndIf

	Local $iVersion=StringRegExp($sHTMLHeader,"(?i)Version:([0-9.]+)",1)
	If @error Then
		; Set it to the initial version if not found
		$iVersion="0.9"
	Else
		$iVersion=$iVersion[0]
	EndIf

	; Make # adjustments based on header start (since it was removed)
	$iFragmentStart-=$iHTMLStart
	$iFragmentEnd-=$iHTMLStart
	If $iSelectionEnd<>-1 Then
		$iSelectionStart-=$iHTMLStart
		$iSelectionEnd-=$iHTMLStart
	EndIf
#cs
	; $iHTMLStart can now be set to 1 (the start of the HTML string obviously) after the above adjustments
	;$iHTMLStart=1	; pointless, as the variable ceases to be of any more use

	; -----------------------------------------------------------------------------------------
	; This would convert the UTF-8 HTML data to Unicode, but it would screw up the Offsets in
	;  data with any kind of Unicode characters in it.
	;	This is why its important to do the conversions *outside* of this function, and only
	;	 *AFTER* the data has been grabbed at the given offsets!
	;
	;	$sUnicodeHTML=BinaryToString($sHTMLData,4)
	; -----------------------------------------------------------------------------------------
#ce
	; Put all the elements in the return array, and return!
	Dim $aReturnArray[8]=[$sHTMLData,$iVersion,$iFragmentStart,$iFragmentEnd,$iSelectionStart,$iSelectionEnd,$sSourceURL,$sHTMLHeader]

	Return $aReturnArray

EndFunc





; ===============================================================================================================================
; <_ClipPutHTML.au3>
;
; Function to put HTML formatted text, or simple Hyperlinks into the Clipboard.
;
; Functions:
;	_ClipPutHTML()			; Simple function to paste HTML code (in UTF-8 format) into the clipboard,
;							;	along with a Plain-Text version
;	_ClipPutHyperlink()		; Sends an HTML-style Hyperlink to the ClipBoard
;	_ClipBoard_FormatHTML()	; Helper function used to apply a CF_HTML header to a piece of HTML code
;							;	*REQUIRED part of calling _ClipBoard_SendHTML
;	_ClipBoard_SendHTML()	; Basically a modified version of _ClipBoard_SetData() for sending HTML + PlainText
;							;	variants to the Clipboard
;
; Dependencies: <Clipboard.au3>
;
; See also:
;	<_ClipGetHTML.au3>
;	<TestClipPutHTML.au3>
;	<_ClipPutHTML_w_History.au3>
;	<_ClipGetRTF.au3>
;	<TestHTMLClipBoardMonitor.au3>	; Monitors & Reports on HTML-formatted ClipBoard data
;	<TestRTFClipBoardMonitor.au3>
;	<_RTF_PullHyperlinks.au3>
;	<TestClipBoardHyperlinkReSorter.au3>; On a HotKey, will pull Hyperlinks from HTML-formatted Clipboard data, sort
;										; 	and resubmit them to the Clipboard (in isolated, sorted format)
;
; Resources:
;	CF_HTML (# 49342) Format @ MSDN: http://msdn.microsoft.com/en-us/library/ms649015(VS.85).aspx
;	Clipboard Formats @ MSDN: http://msdn.microsoft.com/en-us/library/ms649013(VS.85).aspx
;
; Additional Notes:
;	One way to convert Unicode strings to UTF-8 format:
;		$sUTF8String=BinaryToString(StringToBinary($sUnicodeString,4),1)
;
; Author: Ascend4nt, Original _ClipBoard_SetData() function: Paul Campbell (PaulIA)
; ===============================================================================================================================

; ===============================================================================================================================
; Func _ClipPutHTML($sHTML,$sPlainText)
;
; Simple method of placing HTML data, and PlainText equivalent (if available), on the clipboard.
;
; $sHTML = HTML code in UTF-8 format.
;	NOTE: this will paste the *entire* piece of HTML code in the Clipboard.
;		For finer control, see _ClipBoard_FormatHTML() and _ClipBoard_SendHTML()
;		(_ClipPutHyperlink() also uses this customized method of pasting HTML data)
;	One way to convert Unicode strings to UTF-8 format:
;		$sUTF8String=BinaryToString(StringToBinary($sUnicodeString,4),1)
; $sPlainText = (optional, but recommended) The text as it would appear in a non-rich-text based edit control
;	(for example, Notepad). If left blank, pasting will not work in those controls.
;
; Returns:
;	Success: a handle to the HTML Global memory object, with @extended = handle to PlainText memory object
;		NOTE: if @error = -8, the function *partially* succeeded,
;			and the HTML Global memory object is returned. (The setting of the PlainText variant failed)
;	Failure: 0 returned with @error set:
;		@error = 1 = invalid parameter(s)
;		@error = -1 = error allocating global memory object, @extended = 1 if occurred on PlainText object
;		@error = -2 = error locking global memory object, @extended = 1 if occurred on PlainText object
;		@error = -5 = error opening clipboard
;		@error = -6 = error emptying clipboard
;		@error = -7 = error setting clipboard with HTML data
;		@error = -8 = error setting clipboard with PlainText data
;		@error = -9 = error registering HTML Data Clipboard format (no attempt to set Clipboard data is made);
;
; Author: Ascend4nt
; ===============================================================================================================================

Func _ClipPutHTML($sHTMLStr,$sPlainText="")
	Local $sCF_HTMLStr=_ClipBoard_FormatHTML($sHTMLStr)
	If @error Then Return SetError(@error,0,0)
	Local $vRet=_ClipBoard_SendHTML($sCF_HTMLStr,$sPlainText)
	SetError(@error,@extended)
	Return $vRet
EndFunc

; ===============================================================================================================================
; Func _ClipPutHyperlink($sURL,$sLabel="",$sSourceURL="")
;
; Puts a simple Hyperlink into the clipboard, in HTML format.
;
; $sURL = the URL web address (ANSI)
; $sLabel = the Label to put on the Hyperlink. If left as "", it will use the $sURL string
; $sSourceURL = the URL web address that contained the link (useful in downloads?)
;
; Returns:
;	Success: a handle to the HTML Global memory object, with @extended = handle to PlainText memory object
;		NOTE: if @error = -8, the function *partially* succeeded,
;			and the HTML Global memory object is returned. (The setting of the PlainText variant failed)
;	Failure: 0 returned with @error set:
;		@error = 1 = invalid parameter(s)
;		@error = -1 = error allocating global memory object, @extended = 1 if occurred on PlainText object
;		@error = -2 = error locking global memory object, @extended = 1 if occurred on PlainText object
;		@error = -5 = error opening clipboard
;		@error = -6 = error emptying clipboard
;		@error = -7 = error setting clipboard with HTML data
;		@error = -8 = error setting clipboard with PlainText data
;		@error = -9 = error registering HTML Data Clipboard format (no attempt to set Clipboard data is made);
;
; Author: Ascend4nt
; ===============================================================================================================================

Func _ClipPutHyperlink($sURL,$sLabel="",$sSourceURL="")

	; Test parameters. (Label can be converted to a string if something else)
	If Not IsString($sURL) Or Not IsString($sSourceURL) Then Return SetError(1,0,0)

	; Convert Label to a string if it wasn't already (allows passing #'s etc)
	If Not IsString($sLabel) Then $sLabel=String($sLabel)

	; If no Label is specified, use the URL name as the label
	If $sLabel="" Then $sLabel=$sURL

	; 'Sneaky' method of converting regular little-endian 16-bit Unicode to UTF-8 Unicode
	;	(first convert it to UTF-8 *BINARY*, then convert it to a string (pretending its regular ANSI data))
	Local $sUTF8Label=BinaryToString(StringToBinary($sLabel,4),1)

	Local $sHTMLStr="<html><body>" & @CRLF & _
		'<a href="' & $sURL & '">' & $sUTF8Label & '</a>' & @CRLF & _
		"</body>" & @CRLF & "</html>"

	$sHTMLClipStr=_ClipBoard_FormatHTML($sHTMLStr,15,15+StringLen($sURL)+15+StringLen($sUTF8Label)-1,1,-1,$sSourceURL)

	Local $vRet=_ClipBoard_SendHTML($sHTMLClipStr,$sLabel)
	SetError(@error,@extended)
	Return $vRet
EndFunc


; ===============================================================================================================================
; Func _ClipBoard_FormatHTML($sHTMLStr,$iFragmentStart=1,$iFragmentEnd=-1,$iHTMLStart=1,$iHTMLEnd=-1,$sSourceURL="")
;
; Function to apply a CF_HTML header to an HTML string & return the combined string result
;	For use in calling _ClipBoard_SendHTML()
;
; $sHTMLStr = HTML string. (UTF-8 encoding please)
; $iFragmentStart = (optional, defaults to 1): Location in HTML string where the actual data to copy STARTS
; $iFragmentEnd = (optional, defaults to -1): Location in HTML string where the actual data to copy ENDS
;		(if you only know the length, use the formula $iFragmentStart+$iFragmentLen-1 )
;		-1 means end of HTML string
; $iHTMLStart = (optional, defaults to 1): Location where the HTML code starts (typically at top, or at "<html>")
; $iHTMLEnd = (optional, defaults to -1): Location where the HTML code ends (typically at the end, or at right of "</html>")
;		-1 means end of HTML string
; $sSourceURL = (optional): If present, will add a "SourceURL:" line to CF_HTML header. Possibly useful for 'referrer' info
;
; Returns:
;	Success: CF_HTML-Formatted string
;	Failure: "" with @error set to 1 (invalid parameter(s))
;
; Author: Ascend4nt
; ===============================================================================================================================

Func _ClipBoard_FormatHTML($sHTMLStr,$iFragmentStart=1,$iFragmentEnd=-1,$iHTMLStart=1,$iHTMLEnd=-1,$sSourceURL="")

	; Paramater checks
	If Not IsString($sHTMLStr) Then Return SetError(1,0,"")

	Local $iHTMLLen=StringLen($sHTMLStr)

	; Handle defaults
	If $iHTMLEnd=-1 Then $iHTMLEnd=$iHTMLLen
	If $iFragmentEnd=-1 Then $iFragmentEnd=$iHTMLLen

	; Bounds checking
	If $iHTMLStart<1 Or $iHTMLStart>$iHTMLEnd Or $iHTMLEnd>$iHTMLLen Then Return SetError(1,0,"")
	If $iFragmentStart<$iHTMLStart Or $iFragmentStart>$iFragmentEnd Or $iFragmentEnd>$iHTMLEnd Then Return SetError(1,0,"")

	; Size of standard header = 97 (padded offsets):
	;	Version:0.9 & @CRLF
	;	StartHTML:00000000 & @CRLF
	;	EndHTML:00000000 & @CRLF
	;	StartFragment:00000000 & @CRLF
	;	EndFragment:00000000 & @CRLF
	Local $iCF_HTMLLen=97

	; Source URL passed?
	If $sSourceURL<>"" Then
		; Add length of "SourceURL:" + $sSourceURL + 2 (@CRLF) to header size
		$iCF_HTMLLen+=12+StringLen($sSourceURL)
		$sSourceURL="SourceURL:"&$sSourceURL&@CRLF
	EndIf

	; Return Final String
	Return ("Version:0.9" & @CRLF & _
		"StartHTML:"& StringRight("0000000"&($iHTMLStart+$iCF_HTMLLen-1),8) & @CRLF & _
		"EndHTML:"& StringRight("0000000"&($iHTMLEnd+$iCF_HTMLLen),8) & @CRLF & _
		"StartFragment:"& StringRight("0000000"&($iFragmentStart+$iCF_HTMLLen-1),8) & @CRLF & _
		"EndFragment:"& StringRight("0000000"&($iFragmentEnd+$iCF_HTMLLen),8) & @CRLF & _
		$sSourceURL & $sHTMLStr)
EndFunc


; ===============================================================================================================================
; Func _ClipBoard_SendHTML(Const ByRef $sHTMLData,Const ByRef $sPlainText)
;
; Basically a modified version of _ClipBoard_SetData() for sending HTML + PlainText variants to the Clipboard
;	NOTE: CF_HTML format is in UTF-8 encoding. For typical ANSI text, nothing needs to be done,
;		but for Unicode characters, do a conversion like such:
;			$sUTF8String=BinaryToString(StringToBinary($sUnicodeString,4),1)
;	$sPlainText is handled by default as Unicode text
;
; $sHTMLData = the HTML data string WITH the CF_HTML header applied! (UTF-8 encoding!)
;	** Use _ClipBoard_FormatHTML() to apply the header to the string before calling this!!
; $sPlainText = the (Unicode) plain text variant of the HTML data (no rich-text/HTML formatting, just the text)
;
; Returns:
;	Success: a handle to the HTML Global memory object, with @extended = handle to PlainText memory object
;		NOTE: if @error = -8, the function *partially* succeeded,
;			and the HTML Global memory object is returned. (The setting of the PlainText variant failed)
;	Failure: 0 returned with @error set:
;		@error = -1 = error allocating global memory object, @extended = 1 if occurred on PlainText object
;		@error = -2 = error locking global memory object, @extended = 1 if occurred on PlainText object
;		@error = -5 = error opening clipboard
;		@error = -6 = error emptying clipboard
;		@error = -7 = error setting clipboard with HTML data
;		@error = -8 = error setting clipboard with PlainText data
;		@error = -9 = error registering HTML Data Clipboard format (no attempt to set Clipboard data is made);
;
; Author: Original _ClipBoard_SetData() function: Paul Campbell (PaulIA),
;	HTML & Unicode modifications by Ascend4nt
; ===============================================================================================================================

Func _ClipBoard_SendHTML(Const ByRef $sHTMLData,Const ByRef $sPlainText)
	Local $tData, $hLock, $hMemory, $hPTMemory, $iSize, $iCF_HTMLFormat, $iClipErr=0

	; Allocate *Global* system memory for the HTML data & initialize it
	$iSize = StringLen($sHTMLData) + 1
	$hMemory = _MemGlobalAlloc($iSize, $GHND)
	If $hMemory = 0 Then Return SetError(-1, 0, 0)
	$hLock = _MemGlobalLock($hMemory)
	If $hLock = 0 Then Return SetError(-2, 0, 0)
	$tData = DllStructCreate("char[" & $iSize & "]", $hLock)
	DllStructSetData($tData,1,$sHTMLData)
	_MemGlobalUnlock($hMemory)

	If $sPlainText<>"" Then
		; Allocate *Global* system memory for the PlainText variant of HTML data & initialize it
		$iSize = StringLen($sPlainText) + 1
		$hPTMemory = _MemGlobalAlloc($iSize*2, $GHND)	; *2 for Unicode character size
		If $hPTMemory = 0 Then Return SetError(-1, 1, 0)
		$hLock = _MemGlobalLock($hPTMemory)
		If $hLock = 0 Then Return SetError(-2, 1, 0)
		$tData = DllStructCreate("wchar[" & $iSize & "]", $hLock)	; wide (UNICODE) characters
		DllStructSetData($tData,1,$sPlainText)
		_MemGlobalUnlock($hPTMemory)
	Else
		$hPTMemory=0
	EndIf

	If Not _ClipBoard_Open(0) Then Return SetError(-5, 0, 0)
	If Not _ClipBoard_Empty() Then Return SetError(-6, 0, 0)

	;  CF_HTML in experimentation is generally 49342
	$iCF_HTMLFormat=_ClipBoard_RegisterFormat("HTML Format")

	If $iCF_HTMLFormat=0 Then
		$iClipErr=-9
	ElseIf Not _ClipBoard_SetDataEx($hMemory,$iCF_HTMLFormat) Then
		$iClipErr=-7
	ElseIf $sPlainText<>"" And Not _ClipBoard_SetDataEx($hPTMemory,13) Then	; $CF_UNICODETEXT = 13  ($CF_TEXT is 1)
		$iClipErr=-8
	EndIf

	_ClipBoard_Close()

	If $iClipErr Then
		; Total failure to place anything on the clipboard?
		If $iClipErr<>-8 Then Return SetError($iClipErr,0,0)
		; Since the HTML format was successfuly placed on the clipboard,
		;	we'll set the error, clear @extended, and allow return of the Global HTML memory handle
		SetError($iClipErr,0)
	Else
		; Put Global PlainText memory handle into @extended
		SetError(0,$hPTMemory)
	EndIf
	; Return Global HTML memory handle
	Return $hMemory
EndFunc

